/* fold.c - fold long lines */
#include <u.h>
#include <libc.h>
#include <bio.h>

Biobuf bin, bout;

void
fold(Biobuf *bp, int len)
{
	long n;
	static int l = 0;

	while((n = Bgetrune(bp)) > 0){
		if (n == '\n')
			l = 0;
		else
		if (l++ >= len){
			Bputrune(&bout, '\n');
			l = 0;
		}
		Bputrune(&bout, n);
	}
}
void
usage(void)
{
	fprint(2, "usage: %s [-w width] file...\n", argv0);
	exits("usage");
}

void
main(int argc, char *argv[])
{
	Biobuf *bp;
	char *rc = nil;
	int i, len = 80;

	Binit(&bin, 0, OREAD);
	Binit(&bout, 1, OWRITE);

	ARGBEGIN{
		case 'w':
			len = atoi(EARGF(usage()));
			break;
		default:
			usage();
	}ARGEND;

	for (i = 0; i < argc; i++)
		if ((bp = Bopen(argv[i], OREAD)) == nil){
			fprint(2, "%s: %s - cannot open %r\n", argv0, argv[i]);
			rc = "open file";
		}
		else{
			fold(bp, len);
			Bterm(bp);
		}

	if (argc == 0)
		fold(&bin, len);

	exits(rc);
}

